X=[];       %matrix of right-hand variables: constant, lagged endogenous (all variables of first lag,
%            all variables of second lag,..., exogenous
for j=1:lags;
    X=[X y(lags-j+1:nobs-j,:)];
end

X=[X ex(lags+1:end,:)];
if tvar
    Zgam=Zgam(lags+1:end,:);
end
if const
    X=[ones(size(X,1),1) X];
end

y=y(lags+1:end,:);
nobs=size(y,1);
cal=cal(lags+1:end);

% one row per dependent variable: constant, lagged first var, lagged second var,...lagged twice first var, lagged twice second var,..., exogenous;
%ind_n: nvars x size(X,2) matrix of 0-1 to indicate NOT-switching variables for each equation
%ind_s: nvars x size(X,2) matrix of 0-1 to indicate switching variables for each equation
%e.g. every variable has a switching effect:
%ind_s=[ones(nvars,1) ones(nvars,nvars*lags) ones(nvars,exo)];
%ind_n=1-ind_s;

if any(ind_n(:).*ind_s(:))
    'some coefficients are switching and non-switching'
    pause
end

n_sum=sum(ind_n,2);
s_sum=sum(ind_s,2);

X_fix=zeros(nvars*nobs,sum(n_sum));
X_ms=zeros(nvars*nobs,sum(s_sum));

for j=1:nvars;
    X_fix(j:nvars:end,sum(n_sum(1:j))-n_sum(j)+1:sum(n_sum(1:j)))=X(:,ind_n(j,:)==1); %predictor matrix of not switching variables
    X_ms(j:nvars:end,sum(s_sum(1:j))-s_sum(j)+1:sum(s_sum(1:j)))=X(:,ind_s(j,:)==1); %predictor matrix of switching variables
end
Y=reshape(y',nvars*nobs,1); %left-hand vector [y_1t y_2t..y_1t+1 y_2t+1...y_1T y_2T]'
