function [simc,etamc,gammc,parmsmc_n,parmsmc_s,sigmc,detsigmc,loglik,gampost_mean,gampost_chol,etapost,parmspost_mean,parmspost_chol,nupost,sigpost,sstmc,tvpmpost,prob,reject] = ...
    mcmc_msvar(Y,X_fix,X_ms,Zgam,parms_n,parms_s,gam,sig,eta,drum,sst,prm,prinf,nu0,sig0,e0,prmgam,prinfgam,ind_n,ind_s,lags,const,exo,sigswitch,nobs,nvars,it,it0,rth,MMC,bf,perm,perm_id,nst,tvar,gz,test);

states=1:nst;
si=1:nst;
reject=0;
n_sum=sum(ind_n,2);
s_sum=sum(ind_s,2);

mcmc=floor((it-it0)/rth);
parmsmc_n=zeros(length(parms_n),mcmc);
parmsmc_s=zeros(size(X_ms,2),nst,mcmc);
sigmc=zeros(nvars,nvars,nst*sigswitch+(1-sigswitch),mcmc);
detsigmc=zeros(1,nst*sigswitch+(1-sigswitch),mcmc);
loglik=zeros(mcmc,1);
sstmc=zeros(nst,size(sst,2),floor((it-it0)/rth))==1;
simc=zeros(mcmc,nst);
mccnt=1;
mcind=[rth:rth:it-it0];
prob=zeros(nst,size(sst,2));

etamc=[];
tvpmpost=[];
gampost_mean=[];
gampost_chol=[];
gampm=[];
gampc=[];
gammc=[];
chol_ind=chol_indlodiag(size(gam,1));
if ~tvar
    etamc=zeros(nst,nst,mcmc);
elseif tvar
    tvpmpost=zeros(nst,size(sst,2));
    gammc=zeros(size(gam,1),size(gam,2),mcmc);
    gampost_mean=zeros(size(gam,1),size(gam,2),MMC*bf);
    gampost_chol=zeros(length(chol_ind),nst,MMC*bf);
end


parmspost_mean=[];%zeros(npars,MMC*bf);
parmspost_chol=[];%zeros(length(chol_ind),MMC*bf);
etapost=[];%zeros(nst,nst,MMC*bf);
nupost=[];%zeros(1,nst*sigswitch+(1-sigswitch),MMC*bf);
sigpost=[];%zeros(nvars,nvars,nst*sigswitch+(1-sigswitch),MMC*bf);
bf_ind=it0+[1:MMC];%it0+simuni(it-it0,MMC);% bestimmt MMC zeitpunkte aus it-it0 mglichen
Zdim=size(Zgam,2);


%enter iteration
for j=1:it
    if any([1:500:it]==j)
        j
    end
    
    %simulate parameters
    if j<it0+1
        [parms_n,parms_s,Xmat,par,bmean,bvar]=simparinfo(Y,X_fix,X_ms,sst,sig,prm,prinf,nst);
    elseif j>it0
        [parms_n_neu,parms_s_neu,Xmat_neu,par_neu,bmean_neu,bvar_neu]=simparinfo(Y,X_fix,X_ms,sst,sig,prm,prinf,nst);
        
        if lags
            if check_stationary(parms_n_neu,parms_s_neu,const,exo,ind_n,ind_s,nvars,lags,nst);
                parms_n=parms_n_neu;
                parms_s=parms_s_neu;
                Xmat=Xmat_neu;
                par=par_neu;
                bmean=bmean_neu;
                bvar=bvar_neu;
            else
                j
                reject=reject+1;
            end
        else
            parms_n=parms_n_neu;
            parms_s=parms_s_neu;
            Xmat=Xmat_neu;
            par=par_neu;
            bmean=bmean_neu;
            bvar=bvar_neu;
        end
    end
    
    %simulate variance
    if nvars>1
        [sig,detsig,nu1,sig1] =simsiginfo(Y,Xmat,par,sst,nu0,sig0,nst,sigswitch);
    elseif nvars==1
        [sig,detsig,nu1,sig1] =simsiginfo_uni(Y,Xmat,par,sst,nu0,sig0,nst,sigswitch);
    end
    
    %simulate state variable and transition probabilities
    if ~tvar
    [fv sp] = filtvert_mult(Y,X_fix,X_ms,eta,parms_n,parms_s,sig,nvars);
    if nst>1;
        sst = simstate(fv,eta);
        [eta cnt] = simtrans(nst,sst(1:end),e0,1.);
    end
    elseif tvar
        [fv,sp,tvpm] = filtvert_tvp(Y,X_fix,X_ms,Zgam,parms_n,parms_s,gam,sig,nvars,gz);
        [sst_neu,tvp] = simstate_tvp(fv,tvpm,Zgam,gam,gz);
        if ~all((sst_neu-max(sst_neu))==0)
            sst=sst_neu;
        end
        
        [gam,gampm,gampc] = simgamlogit(gam,Zgam,sst,prmgam,prinfgam,nst,drum,gz);        
    end

    %permute
    %si=[1 2];
    if and(perm,nst>1)  %permute randomly
        si = randperm(nst);
    elseif and(~perm,nst>1) %permute to fulfill a state-identifying restriction, adjust on the following line
        [parms_sort si]  = sort(parms_s(perm_id,:));
        if test
            si=[1 2];
        end
    end
    if any([1:nst]~=si)
    
        if sigswitch;
            sig=sig(:,:,si);
        end
        if sum(s_sum)>0;
            parms_s=parms_s(:,si);
        end
        
        if ~tvar
            eta = eta(si,si);
        elseif tvar
            if gz
                sigam=[kron((si'-1)*Zdim,ones(Zdim,1))+kron(ones(Zdim,1),[1:Zdim]');si'+Zdim*nst];
            elseif ~gz
                sigam=[[1:Zdim]';si'+Zdim];
            end
            gam=gam(sigam,si);
            prmgam=prmgam(sigam,si);
            %             prinfgam=prinfgam(sigam,sigam);
            gampm=gampm(sigam,si);
            gampc=gampc(sigam,sigam,si);
            if ~perm
                gam=gam-kron(ones(1,size(gam,2)),gam(:,1));
                prmgam=prmgam-kron(ones(1,size(gam,2)),prmgam(:,1));
                gampm=gampm-kron(ones(1,size(gam,2)),gampm(:,1));
                gampc=gampc+gampc(:,:,ones(1,nst));
            end
        end
        sst = si(sst);   
    end
    
    %save
    if any((j-it0)==mcind)
        simc(mccnt,:)=si;
        if ~tvar
            etamc(:,:,mccnt) = eta;
        elseif tvar
            gammc(:,:,mccnt)=gam;
        end
        if sum(s_sum)>0
            parmsmc_s(:,:,mccnt)=parms_s;
        end
        sigmc(:,:,:,mccnt)=sig;
 %       detsigmc(:,:,mccnt)=detsig;
        parmsmc_n(:,mccnt)=parms_n;
%        loglik(mccnt)=sp;
        sstmc(:,:,mccnt) = (sst(ones(1,nst),:) == states(ones(1,nobs+1),:)');
%      end


        
%         if bf==1
%             if any(bf_ind==j) % MCMC sample is used to build q
%                 sjm=sum(bf_ind==j);
%                 sj=(bf_ind==j);%
                gampost_mean(:,:,mccnt)=gampm;
                for j=find(any(gampm,1))
                    gpchol=chol(gampc(:,:,j))';
                    gampost_chol(:,j,mccnt)=gpchol(chol_ind)';
                end
%                 if nst>1;
%                     etapost(:,:,bf_ind==j)=cnt(:,:,ones(1,sjm));
%                 end
%                 parmspost_mean(:,bf_ind==j)=bmean(:,ones(1,sjm));
%                 bvarchol=chol(bvar)';
%                 parmspost_chol(:,bf_ind==j)=kron(ones(1,sjm),bvarchol(chol_ind)');
%                 nupost(1,:,bf_ind==j)=nu1(1,:,ones(1,sjm)); 
%                 sigpost(:,:,:,bf_ind==j)=sig1(:,:,:,ones(1,sjm));
            %end
             mccnt=mccnt+1;
        end   
        
        
end

reject = reject/mcmc;

