function fd = pmultnormlog(beta,prm,prv)

% auswerten einer multivariaten normalverteilung fuer verscheidene argumente mit verschiedenen
% parametern - ergebnis: log des funktionswertes

%input: 
% beta ... spaltenvektor (1 argument)
%      ... matrix; anzahl der spalten = verschiedene argumente; die spalten  enthalten
%                  die argumante
% prm ... mean - spaltenvektor
% prv ... varianz

%output: funktionswerte ... 1 zeile


k = size(beta,1);
nst = size(prm,2);
fd=zeros(1,nst);

for j=1:nst;
fln = -0.5*log(det(prv(:,:,j)))-0.5*k*log(2*pi);
v=chol(inv(prv(:,:,j)))'*(beta-prm(:,j));
% flg = -0.5*sum(v.*v,1);
flg = -0.5*(v'*v);
fd(1,j) = fln+flg;
end
