function [sst,tvp] = simstate_tvp(fv,trans,Zgam,gam,gz)
% fv,tvpm,Zgam,gam

[n nst] = size(fv);
states=1:nst;
Zdim=size(Zgam,2);
rnd = rand(n,1);
sst = zeros(1,n);
p = fv(end,:);
st = sum(cumsum(p) < rnd(n)) + 1;          % sampling
sst(n) = st;

for i = (n-1):-1:1
    p = fv(i,:) .* trans(:,st,i)';
    p = p / sum(p);
    st = sum(cumsum(p) < rnd(i)) + 1;      % sampling
    sst(i) = st;
end

Dt=sst(ones(1,nst),:)'==states(ones(length(sst),1),:);
Dst=kron(Dt,ones(1,Zdim));
if gz
    Zgamt=[kron(ones(1,nst),Zgam).*Dst(1:end-1,:), Dt(1:end-1,:)];
elseif ~gz
    Zgamt=[Zgam, Dt(1:end-1,:)];
end
tvp= exp(Zgamt*gam - kron(log(sum(exp(Zgamt*gam),2)),ones(1,nst)))';

