        %prior specification %CHECK in particular lines 47-54 below
        %priors for the parameters
        minn_var=0.09; %prior variance for the first autoregressive lag
        minn_cov=0.25;  %shrink factor for prior variance on lags of other variables (Minnesota type prior)
        prm_n=zeros(size(X_fix,2),1);
        prm_s=zeros(size(X_ms,2)*nst,1);
        
        prm=[prm_n;prm_s]; %prior mean of parameters
        
        prinf_n=ones(size(X_fix,2),1)*4;
        prinf_s=ones(size(X_ms,2)*nst,1)*4;
        
        if lags
        prminn=minnesota(y,X(:,const+1:nvars*lags+const),lags,minn_var,minn_cov)';
        %minnesota prior for autoregressive lags, transpose for subsequent indexing
        
        [ind_VAR_n,ind_parms_n]=findparms(ind_n,const,exo);
        prinf_n(ind_VAR_n)=prminn(ind_n(:,1+const:nvars*lags+const)'==1);% vector from minnesota-matrix;
        
        [ind_VAR_s,ind_parms_s]=findparms(ind_s,const,exo);
        for j=1:nst;
            prinf_s([ind_VAR_s+(j-1)*size(X_ms,2)])=prminn(ind_s(:,1+const:nvars*lags+const)'==1);%vector from minnesota-matrix;
        end
        end
        
        prinf=diag([prinf_n;prinf_s]); %prior information on parameter
        if noinf
            prinf=zeros(size(prinf));
        end
        
        %prior for the error covariance matrix
        sigm=eye(nvars)*0.1; %prior mean for error covariance matrix
        if nvars>1
        nu0=nvars+2;sig0=sigm*((nu0-nvars-1)/2); %degrees of freedom and scale matrix of wishart prior for sig^-1
        elseif nvars==1
            nu0=5;sig0=0.25;
        end

        %prior for the transition parameters
        e0=[];
        gadim=size(Zgam,2)+size(Zgam,2)*(nst-1)*gz+nst;
        prmgam=[];
        prinfgam=[];
        if ~tvar
            e0=(nst>1)*ones(nst)+eye(nst); %parameter of the dirichlet prior for constant transition probabilities (2s on the diagonal and 1s off-diagonal)
        elseif tvar
            if gz
                prmgam=[zeros(gadim,1) [0 0 -1 1 ]'];%zeros(gadim,nst)
                %prinfgam=diag([7.11;6.25;16*ones(nst,1)]);%*0.25;%*0.0625;
                prinfgam=diag([0.04;0.04;1;1]);
            elseif ~gz
                prmgam=[zeros(gadim,1) [0 -1 1]'];
                prinfgam=diag([0.16;ones(nst,1)]);
            end
        end
